#!/bin/bash

echo "Installing Build Enviroment"
sudo cat > /etc/apt/sources.list.d/raspbian.list <<EOC
deb http://raspbian.raspberrypi.org/raspbian/ stretch main contrib non-free rpi
EOC
sudo apt-get update
sudo apt-get install -y binutils libtool libstdc++-4.9-dev gcc-4.9 gcc g++-4.9 g++ dpkg-dev

echo "Installing Bluetooth Dependencies"
{ echo 'Yes, do as I say!'; yes Y; } | sudo apt-get install autoconf bluez pi-bluetooth bluez-tools libbluetooth-dev libglib2.0-dev libsbc-dev

echo "Cloning Bluez-Alsa repo"
cd /tmp
git clone -b v3.1.0 https://github.com/Arkq/bluez-alsa.git

echo "Building Bluez-Alsa"
cd bluez-alsa
autoreconf --install
mkdir build && cd build
../configure --disable-hcitop --with-alsaplugindir=/usr/lib/arm-linux-gnueabihf/alsa-lib
make 

echo "Installing Bluez-Alsa"
sudo make install

cat > /lib/systemd/system/bluezalsa.service <<EOC
[Unit]
Description=BluezAlsa proxy
Requires=bluetooth.service
After=bluetooth.service
[Service]
Type=simple
User=root
Group=audio
ExecStart=/usr/bin/bluealsa --a2dp-force-audio-cd
[Install]
WantedBy=multi-user.target
EOC

mpd_conf_tmpl='/volumio/app/plugins/music_service/mpd/mpd.conf.tmpl'
sudo mv $mpd_conf_tmpl ${mpd_conf_tmpl}.bak
{ sed -rz 's/(\# bluealsa Output \(begin\) \#+).*(\#+ bluealsa Output \(end\) \#\n)//g' ${mpd_conf_tmpl}.bak; \
cat << EOC
# bluealsa Output (begin) #####################################################
audio_output {
        type "alsa"
        name "bluealsa"
        device "bluealsa"
        mixer_type "software"
}
####################################################### bluealsa Output (end) #
EOC
} > $mpd_conf_tmpl

sudo systemctl daemon-reload
sudo systemctl enable bluezalsa.service

#requred to end the plugin install
echo "plugininstallend"
